#include <stdio.h>
#include "AD18E22X.h"
#include "periph.h"
#include "AD18E22X_DEF.h"

void GPIO_Init(void)
{
     TRISA = 0X00;       //PA口设置为输出模式
     PA0PU = 1;          //PA0上拉关闭
     PA1PU = 1;          //PA1上拉关闭
     PA2PU = 1;          //PA2上拉关闭
     PA4PU = 1;          //PA4上拉关闭
     PA5PU = 1;          //PA5上拉关闭
     PAPD  = 0x3F;       //PA口下拉关闭
     PA0OD = 0;          //PA0 OD关闭
     PA1OD = 0;          //PA1 OD关闭
     PA2OD = 0;          //PA2 OD关闭
     PA4OD = 0;          //PA4 OD关闭
     PA5OD = 0;          //PA5 OD关闭
     TRISB = 0X00;       //PB口设置为输出模式
     PBPU  = 0x3F;       //PB口上拉关闭
     TRISC = 0X00;       //PC口设置为输出模式
     PCPU  = 0x7F;       //PC上拉关闭
     PC6=1;              //注：PC6在低功耗模式下需要关闭上拉并且输出高
     PC6PD = 1;          //PC6口下拉关闭  PC6控制PMOS时需要设置成输入模式，
                         //通过控制上下拉电阻1K实现PMOS开关，减少PMOS开关导致电源电压过充现象
}
/*******************************************************************************
* Description    : ADC初始化
* Input          : None
* Output         : None
* Return         : None
* Attention	     : 默认采集FVR 1.2V ->反推VCC电压
*******************************************************************************/
void ADC_Exce(void)
{
	unsigned short  timeout; 
   
	GO  = 1;  		//start ADC

	//等待AD转换结束
	timeout = 0;
	while(GO)
	{
		CLRWDT();		
		timeout++;
		if(timeout > 2000)
		{
			ADON = 0;
			GO  = 0;
			ADON = 1;
			GO  = 1;
			
			break;
		}
	}
}

/*

*/
void ADC_Config(void)
{
	ADCON0 = ADFM_RIGHT|ADC_FVR|ADC_EN;  //配置FVR为ADC采集通道，使能A/D模拟使能位
	ADCON1 = ADVREF_VDD|ACQT_15|ADCS_FSYS_8;  //参考电压选择VDD，延时采集时间选择15TAD  A/D转换时钟选择FOSC/8

	GIEH   = 1; 
	GIEL   = 1;
	IPEN   = 1;
	ADIP = 1;//ADC的高优先级使能
	ADIE = 1;//ADC的中断使能位
	ADIF = 0;//初始化ADC的中断标志位
	

}

void fvr_int(void)
{
	 FVRCON = FVR_SEL_1V2|FVR_PG1|FVR_EN;//使能FVR，1倍放大，选择VREF1P0(1.2V)通道
}
