#include "AD18E22X.h"
#include <stdio.h>
#include "common.h"
#include "AD18E22X_DEF.h"

/*******************************************************************************
// ----Function: GPIO_Init
// --Parameters: 
// -----Returns: None   
//---------Note:所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
     TRISA = 0X00;       //PA口设置为输出模式
     PA0PU = 1;          //PA0上拉关闭
     PA1PU = 1;          //PA1上拉关闭
     PA2PU = 1;          //PA2上拉关闭
     PA4PU = 1;          //PA4上拉关闭
     PA5PU = 1;          //PA5上拉关闭
     PAPD  = 0x3F;       //PA口下拉关闭
     PA0OD = 0;          //PA0 OD关闭
     PA1OD = 0;          //PA1 OD关闭
     PA2OD = 0;          //PA2 OD关闭
     PA4OD = 0;          //PA4 OD关闭
     PA5OD = 0;          //PA5 OD关闭
     TRISB = 0X00;       //PB口设置为输出模式
     PBPU  = 0x3F;       //PB口上拉关闭
     TRISC = 0X00;       //PC口设置为输出模式
     PCPU  = 0x7F;       //PC上拉关闭
     PC6=1;              //注：PC6在低功耗模式下需要关闭上拉并且输出高
     PC6PD = 1;          //PC6口下拉关闭  PC6控制PMOS时需要设置成输入模式，
                         //通过控制上下拉电阻1K实现PMOS开关，减少PMOS开关导致电源电压过充现象 	
}


void Timer0_Timer(unsigned char T0_CS,unsigned char T0_SE,unsigned char CS_EN,unsigned char T0_FD)
{

	if (T0_CS == T0CS_T0CKI_PA1)
	{
		TRISA1 = 1;            //PA1设置输入（使用t0cki时配置）
	}
	T0CON = 0X00;
	T0CON = T0_CS|T0_SE|CS_EN|T0_FD;       //选择计数时钟
	
	PR0 = 156;                 //tmr0计数周期
	TMR0 = 0;                  //设置tmr0初值

	TMR0IP = 1;     //设tmr0中断为高优先级
	TMR0IF = 0;     //清tmr0中断
	TMR0IE = 1;     //打开tmr0中断使能

}

void Timer1_edge_io_mode1(void)
{
	TRISB3 = 1;       //设置PB1的方向为输入
	// TRISB4 = 1;       //设置PB4的方向为输入
	// TRISC2 = 1;       //设置PC2的方向为输入

	TMR1H  = 0X00;
	TMR1L  = 0X00;
	T1CON0 = T1CK_FCPU|T1CKPS_DIV4|TM1_ON;  // 4分频   16M   使能timer1 
    T1CON1 = T1CAP_RISEEDGE|T1CH2_PB3|T1M_MODE_CAPTURE1;  //上升沿开始，下降沿结束，模式1  测量通道（PB3作为检测）
	TMR1IF = 0;      //清中断标志
	TMR1IP = 1;		 //高优先级中断
	TMR1IE = 1;      //开TMR1中断

	T1PRIF = 0;		//Timer1捕捉上升沿清中断标志
	T1PRIP = 1;		//Timer1捕捉上升沿中断优先级
	T1PRIE = 1;		//打开捕捉上升沿中断

	T1PDIF = 0;		//Timer1捕捉下降沿清中断标志
	T1PDIP = 1;		//Timer1捕捉下降沿中断优先级
	T1PDIE = 1;		//打开捕捉下降沿中断	
}


