#include "AD18E22X.h"
#include <stdio.h>
#include "common.h"

/*******************************************************************************
// ----Function: GPIO_Init
// --Parameters: 
// -----Returns: None   
//---------Note:所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
     TRISA = 0X00;       //PA口设置为输出模式
     PA0PU = 1;          //PA0上拉关闭
     PA1PU = 1;          //PA1上拉关闭
     PA2PU = 1;          //PA2上拉关闭
     PA4PU = 1;          //PA4上拉关闭
     PA5PU = 1;          //PA5上拉关闭
     PAPD  = 0x3F;       //PA口下拉关闭
     PA0OD = 0;          //PA0 OD关闭
     PA1OD = 0;          //PA1 OD关闭
     PA2OD = 0;          //PA2 OD关闭
     PA4OD = 0;          //PA4 OD关闭
     PA5OD = 0;          //PA5 OD关闭
     TRISB = 0X00;       //PB口设置为输出模式
     PBPU  = 0x3F;       //PB口上拉关闭
     TRISC = 0X00;       //PC口设置为输出模式
     PCPU  = 0x7F;       //PC上拉关闭
     PC6=1;              //注：PC6在低功耗模式下需要关闭上拉并且输出高
     PC6PD = 1;          //PC6口下拉关闭  PC6控制PMOS时需要设置成输入模式，
                         //通过控制上下拉电阻1K实现PMOS开关，减少PMOS开关导致电源电压过充现象       
}

/*******************************************************************************
// ----Function: Timer0_Init
// --Parameters: 
// -----Returns: None   
//---------Note: 定时器0初始化，定时10ms
				Fcpu作为TMR0时钟：
					4T  t=PR0*定时器0分频系数*4T/16MHz
					2T  t=PR0*定时器0分频系数*2T/16MHz
				其它时钟源作为TMR0时钟：
					t=PR0*定时器0分频系数/osc
*******************************************************************************/
void Timer1_Timer(void)
{
	TMR1H  = 0XFC;     //10ms
	TMR1L  = 0X18;
	T1CON0 = 0X25;     //  4分频   16M     使能timer1
	T1CON1 = 0X00;     //   模式0

	TMR1IF = 0;      //清中断标志
	TMR1IP = 1;		 //高优先级中断
	TMR1IE = 1;      //开TMR1中断	

	// WDTCON = 0X01;
	// ADCON0 = 0X01;
	// ADCON1 = 0XBE;
	// ADCON2 = 0X01;
	
	// ADIF = 0;      //清中断标志
	// ADIP = 1;		 //高优先级中断
	// ADIE = 1;      //开AD中断	

}

void Timer1_edge(void)
{

	TRISA4 = 1;

	TMR1H  = 0X0E;
	TMR1L  = 0X10;
	T1CON0 = 0X25;  // 4分频   16M   使能timer1
	T1CON1 = 0X02;  //上升沿开始，下降沿结束，模式1

	TMR1IF = 0;      //清中断标志
	TMR1IP = 1;		 //高优先级中断
	TMR1IE = 1;      //开TMR1中断
	INT2IF = 0;
	INT2IP = 1;
	INT2IE = 1;

	// PR2H = 0X03;
	// PR2L = 0XE8;
	// TMR1H  = 0X00;
	// TMR1L  = 0X00;
	// T2CON = 0X05; 
	// TMR2IF = 0;      //清中断标志
	// TMR2IP = 1;		 //高优先级中断
	// TMR2IE = 1;      //开TMR2中断	
}
